/*
 * Copyright 2006-2008 The FLWOR Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.

 */
 
#if defined STDAFX
#include <iostream>
#include <stdexcept>
#include <cassert>
#include <cstring>
#include <memory>

#include <sstream>
#include <xfwrap>
#include <xfwrap1>
#include <istream>
#include <cstdio>
#include <xxshared>
#include <crtdefs.h>
#include <map>
#include <set>
//#include <poppack.h>
//#include <xxtype_traits>
//#include <xxcallwrap>

// #include <xxcallpmf>
// //#include <xxbind0>
// //#include <xxbind1>
// //#include <xxresult>
// #include <zorba/audit.h>
// #include "api/auditimpl.h"
// #include <zorba/audit.h>

 //#include "unicode/unistr.h"
 #include "runtime/sequences/sequences.h"
 #include "diagnostics/xquery_diagnostics.h"
 #include "xercesc/util/xercesdefs.hpp"
 #include "runtime/collections/collections.h"
 #include "unicode/utypes.h"
 #include "zorba/config.h"
 #include "store/api/store.h"
 #include "zorba/zorba.h"
 #include "zorba/api_shared_types.h"
 #include "compiler/parsetree/parsenodes.h"
 #include "compiler/parser/parse_constants.h"
 //#include "compiler/api/compilercb.h"
 #include "zorbautils/checked_vector.h"
 #include "compiler/parser/xquery_driver.h"
 #include "util/sorter.h"
 #include "compiler/xqueryx/xqueryx_to_xquery.h"
// #include "compiler/xqueryx/xqueryx_xslt.h"
//#include "compiler/parser/xquery_scanner.h"
//#include "compiler/parsetree/parsenode_base.h"
//#include "compiler/parsetree/parsenode_visitor.h"
// #include "runtime/core/flwor_iterator.h"
// #include "context/static_context.h"
// #include "zorbautils/fatal.h"
// #include "runtime/base/unarybase.h"
// #include "compiler/expression/expr_consts.h"
// #include "api/iterator_singleton.h"
// #include "runtime/visitors/printer_visitor_api.h"
// //#include "compiler/parsetree/parsenode_print_dot_visitor.h"
// //#include "compiler/parsetree/parsenode_print_dot_visitor.h"
// //#include "runtime/visitors/planiter_visitor_impl_code.h"
// //#include "runtime/visitors/planiter_visitor_impl_include.h"
// //#include "runtime/visitors/printer_visitor_impl.h"
// //#include "runtime/core/path.h"
// #include "compiler/expression/ft_expr.h"
// #include "compiler/expression/ftnode.h"
// #include "compiler/parser/query_loc.h"
// #include "util/cxx_util.h"
// #include "util/indent.h"
// #include "util/stl_util.h"
// #include "diagnostics/xquery_diagnostics.h"
// #include "zorbatypes/numconversions.h"

// #include "api/serialization/serializable.h"
// #include "api/serialization/serializer.h"
// #include "api/collectionimpl.h"
// #include "api/dynamiccontextimpl.h"
// #include "api/fileimpl.h"
// #include "api/functionimpl.h"
// #include "api/invoke_item_sequence.h"
// #include "api/itemfactoryimpl.h"
// #include "api/resultiteratorchainer.h"
// #include "api/resultiteratorimpl.h"
// #include "api/sax2impl.h"
// #include "api/serializerimpl.h"
// #include "api/staticcontextimpl.h"
// #include "api/storeiteratorimpl.h"
// #include "api/unmarshaller.h"
// #include "api/uri_resolver_wrappers.h"
// #include "api/vectoriterator.h"
// #include "api/xmldatamanagerimpl.h"
// //#include "api/xqueryimpl.h"
// #include "api/zorbaimpl.h"
// #include "capi/cdynamic_context.h"
// #include "capi/cexpression.h"
// #include "capi/cexternal_function.h"
// #include "capi/cimplementation.h"
// #include "capi/csequence.h"
// #include "capi/cstatic_context.h"
// #include "capi/error.h"
// #include "capi/external_module.h"
// #include "capi/single_item_sequence.h"
// #include "capi/user_item_sequence.h"
// #include "compiler/parser/flexlexer.h"
// #include "compiler/parser/ft_types.h"
// #include "compiler/parser/symbol_table.h"
// #include "compiler/parser/xqdoc_comment.h"
// #include "compiler/parsetree/parsenode_print_xml_visitor.h"
// #include "compiler/parsetree/parsenode_print_xqdoc_visitor.h"
// #include "compiler/parsetree/parsenode_print_xquery_visitor.h"
// #include "compiler/parsetree/parsenode_xqdoc_visitor.h"
// #include "compiler/translator/prolog_graph.h"
// #include "compiler/translator/translator.h"
// #include "compiler/codegen/plan_visitor.h"
// #include "compiler/expression/abstract_expr_visitor.h"
// #include "compiler/expression/expr.h"
// #include "compiler/expression/expr_annotations.h"
// #include "compiler/expression/expr_base.h"
// #include "compiler/expression/expr_classes.h"
// #include "compiler/expression/expr_iter.h"
// #include "compiler/expression/expr_utils.h"
// #include "compiler/expression/expr_visitor.h"
// #include "compiler/expression/flwor_expr.h"
// //#include "compiler/expression/fo_expr.h"
// #include "compiler/expression/ftnode_classes.h"
// #include "compiler/expression/ftnode_visitor.h"
// #include "compiler/expression/function_item_expr.h"
// #include "compiler/expression/path_expr.h"
// #include "compiler/expression/script_exprs.h"
// #include "compiler/expression/update_exprs.h"
// #include "compiler/expression/var_expr.h"
// #include "compiler/rewriter/framework/rewriter.h"
// #include "compiler/rewriter/framework/rewriter_context.h"
// #include "compiler/rewriter/framework/rule_driver.h"
// #include "compiler/rewriter/framework/sequential_rewriter.h"
// #include "compiler/rewriter/rewriters/common_rewriter.h"
// #include "compiler/rewriter/rewriters/default_optimizer.h"
// #include "compiler/rewriter/rewriters/phase1_rewriter.h"
// #include "compiler/rewriter/rules/ruleset.h"
// #include "compiler/rewriter/rules/rule_base.h"
// #include "compiler/rewriter/rules/type_rules.h"
// #include "compiler/rewriter/tools/dataflow_annotations.h"
// #include "compiler/rewriter/tools/expr_tools.h"
// #include "compiler/rewriter/tools/udf_graph.h"
// #include "compiler/xqddf/collection_decl.h"
// #include "compiler/xqddf/value_ic.h"
// #include "compiler/xqddf/value_index.h"
// #include "compiler/semantic_annotations/annotations.h"
// #include "compiler/semantic_annotations/annotation_holder.h"
// #include "compiler/semantic_annotations/annotation_keys.h"
// #include "compiler/api/compiler_api.h"
// #include "compiler/api/compiler_api_impl.h"
// #include "system/globalenv.h"
// #include "system/properties.h"
// #include "system/zorba_properties.h"
// #include "context/decimal_format.h"
// #include "context/default_uri_mappers.h"
// #include "context/default_url_resolvers.h"
// #include "context/dynamic_context.h"
// #include "context/dynamic_loader.h"
// #include "context/internal_uri_resolvers.h"
// //#include "context/namespace_context.h"
// #include "context/root_static_context.h"
// #include "context/sctx_map_iterator.h"
// #include "context/standard_uri_resolvers.h"
// #include "context/static_context_consts.h"
// #include "context/stemmer_wrappers.h"
// #include "context/uri_resolver.h"
// #include "context/uri_resolver_wrapper.h"
// //#include "diagnostics/assert.h"
// #include "diagnostics/diagnostic.h"
// #include "diagnostics/dict.h"
// #include "diagnostics/dict_impl.h"
// #include "diagnostics/StackWalker.h"
// #include "diagnostics/user_error.h"
// #include "diagnostics/user_exception.h"
// #include "diagnostics/xquery_exception.h"
// #include "diagnostics/xquery_stack_trace.h"
// #include "diagnostics/xquery_warning.h"
// #include "diagnostics/zorba_exception.h"
// //#include "functions/annotation.h"
// #include "functions/external_function.h"
// #include "functions/function.h"
// #include "functions/function_consts.h"
// #include "functions/function_impl.h"
// #include "functions/func_accessors_impl.h"
// #include "functions/func_apply.h"
// #include "functions/func_arithmetic.h"
// #include "functions/func_booleans_impl.h"
// #include "functions/func_durations_dates_times_impl.h"
// #include "functions/func_enclosed.h"
// #include "functions/func_eval.h"
// #include "functions/func_hoist.h"
// #include "functions/func_index_ddl.h"
// #include "functions/func_node_sort_distinct.h"
// #include "functions/func_numerics_impl.h"
// #include "functions/func_reflection.h"
// #include "functions/func_sequences_impl.h"
// #include "functions/func_var_decl.h"
// #include "functions/library.h"
// #include "functions/signature.h"
// #include "functions/udf.h"
// #include "runtime/full_text/thesauri/decode_base128.h"
// #include "runtime/full_text/thesauri/encoded_list.h"
// #include "runtime/full_text/thesauri/iso2788.h"
// #include "runtime/full_text/thesauri/wn_db_segment.h"
// #include "runtime/full_text/thesauri/wn_synset.h"
// #include "runtime/full_text/thesauri/wn_thesaurus.h"
// #include "runtime/full_text/thesauri/wn_types.h"
// #include "runtime/full_text/thesauri/xqftts_relationship.h"
// #include "runtime/full_text/thesauri/xqftts_thesaurus.h"
// #include "runtime/full_text/ft_match.h"
// #include "runtime/full_text/ft_query_item.h"
// #include "runtime/full_text/ft_single_token_iterator.h"
// #include "runtime/full_text/ft_stop_words_set.h"
// #include "runtime/full_text/ft_thesaurus.h"
// #include "runtime/full_text/ft_token_matcher.h"
// #include "runtime/full_text/ft_token_seq_iterator.h"
// #include "runtime/full_text/ft_token_span.h"
// #include "runtime/full_text/ft_wildcard.h"
// #include "runtime/full_text/full_text.h"
// #include "runtime/full_text/apply.h"
// #include "runtime/full_text/ft_util.h"
// #include "runtime/collections/collections_base.h"
// #include "runtime/core/apply_updates.h"
// #include "runtime/core/arithmetic_impl.h"
// #include "runtime/core/constructors.h"
// #include "runtime/core/fncall_iterator.h"
// #include "runtime/core/internal_operators.h"
// #include "runtime/core/item_iterator.h"
// #include "runtime/core/nodeid_iterators.h"
// #include "runtime/core/path_iterators.h"
// #include "runtime/core/sequencetypes.h"
// #include "runtime/core/trycatch.h"
// #include "runtime/core/var_iterators.h"
// #include "runtime/numerics/NumericsImpl.h"
// #include "runtime/booleans/BooleanImpl.h"
// #include "runtime/base/binarybase.h"
// #include "runtime/base/narybase.h"
// #include "runtime/base/noarybase.h"
// #include "runtime/base/plan_iterator.h"
// #include "runtime/sequences/SequencesImpl.h"
// #include "runtime/visitors/iterprinter.h"
// #include "runtime/misc/materialize.h"
// #include "runtime/scripting/scripting.h"
// #include "types/schema/EventSchemaValidator.h"
// #include "types/schema/LoadSchemaErrorHandler.h"
// #include "types/schema/PrintSchema.h"
// #include "types/schema/revalidateUtils.h"
// #include "types/schema/schema.h"
// #include "types/schema/SchemaValidatorFilter.h"
// #include "types/schema/StrX.h"
// #include "types/schema/validate.h"
// #include "types/schema/ValidationEventHandler.h"
// #include "types/schema/xercesIncludes.h"
// #include "types/schema/XercesParseUtils.h"
// #include "types/schema/XercSchemaValidator.h"
// #include "types/casting.h"
// #include "types/collation.h"
// #include "types/node_test.h"
// #include "types/root_typemanager.h"
// #include "types/typeconstants.h"
// #include "types/typeimpl.h"
// #include "types/typemanager.h"
// #include "types/typemanagerimpl.h"
// #include "types/typeops.h"
// #include "util/fx/fxarray.h"
// #include "util/fx/fxcharheap.h"
// #include "util/ascii_util.h"
// #include "util/atomic_int.h"
// #include "util/auto_vector.h"
// #include "util/curl_util.h"
// #include "util/dir.h"
// #include "util/dynamic_bitset.h"
// #include "util/empty.h"
// #include "util/error_util.h"
// #include "util/fs_util.h"
// #include "util/hashmap.h"
// //#include "util/hashmap32.h"
// #include "util/less.h"
// #include "util/mmap_file.h"
// #include "util/nonatomic_int.h"
// #include "util/omanip.h"
// #include "util/oseparator.h"
// #include "util/regex.h"
// #include "util/singleton.h"
// #include "util/string_util.h"
// #include "util/threads.h"
// #include "util/tokenbuf.h"
// #include "util/tracer.h"
// #include "util/triple.h"
// #include "util/unicode_categories.h"
// #include "util/unicode_util.h"
// #include "util/uri_util.h"
// #include "util/utf8_string.h"
// #include "util/utf8_util.h"
// #include "util/utf8_util_base.h"
// #include "util/void_int.h"
// #include "util/xml_util.h"
// #include "zorbamisc/config/platform.h"
// //#include "zorbaserialization/archiver.h"
// #include "zorbaserialization/base64impl.h"
// #include "zorbaserialization/bin_archiver.h"
// //#include "zorbaserialization/class_serializer.h"
// #include "zorbaserialization/mem_archiver.h"
// #include "zorbaserialization/serialization_engine.h"
// #include "zorbaserialization/template_serializer.h"
// #include "zorbaserialization/xml_archiver.h"
// #include "zorbaserialization/zorba_class_serializer.h"
 #include "zorbatypes/mapm/m_apm_lc.h"
 #include "zorbatypes/datetime/parse.h"
 //#include "zorbatypes/binary.h"
 #include "zorbatypes/chartype.h"
 #include "zorbatypes/collation_manager.h"
 //#include "zorbatypes/datetime.h"
 //#include "zorbatypes/decimal.h"
 //#include "zorbatypes/duration.h"
 //#include "zorbatypes/floatimpl.h"
 #include "zorbatypes/ft_token.h"
 //#include "zorbatypes/integer.h"
 #include "zorbatypes/libicu.h"
 #include "zorbatypes/m_apm.h"
 //#include "zorbatypes/rchandle.h"
 #include "zorbatypes/rclock.h"
 //#include "zorbatypes/regex_ascii.h"
 #include "zorbatypes/schema_types.h"
 #include "zorbatypes/timezone.h"
 #include "zorbatypes/transcoder.h"
 #include "zorbatypes/URI.h"
 #include "zorbatypes/xerces_xmlcharray.h"
 #include "zorbatypes/zorbatypes_decl.h"
 #include "zorbatypes/zstring.h"
 #include "zorbautils/stemmer/sb_stemmer.h"
 #include "zorbautils/condition.h"
 #include "zorbautils/hashfun.h"
 #include "zorbautils/hashmap.h"
 #include "zorbautils/hashmap_itemp.h"
 #include "zorbautils/hashmap_str_obj.h"
 #include "zorbautils/hashmap_zstring.h"
 #include "zorbautils/hashset.h"
 #include "zorbautils/hashset_itemh.h"
 #include "zorbautils/icu_tokenizer.h"
 #include "zorbautils/latch.h"
 #include "zorbautils/locale.h"
 #include "zorbautils/lock.h"
 #include "zorbautils/mutex.h"
 #include "zorbautils/runnable.h"
 #include "zorbautils/SAXParser.h"
 #include "zorbautils/stack.h"
 #include "zorbautils/stemmer.h"
 #include "zorbautils/string_util.h"
 //#include "zorbautils/synchronous_logger.h"
 #include "zorbautils/tokenizer.h"
 #include "unit_tests/unit_test_list.h"
 #include "zorba/diagnostic_handler.h"
 #include "zorba/xquery_warning.h"
 #include "runtime/full_text/ftcontains_visitor.h"
#endif
/* vim:set et sw=2 ts=2: */
